diff --git a/plugins/imfile/imfile.c b/plugins/imfile/imfile.c
index 950b62918..a5d20823f 100644
--- a/plugins/imfile/imfile.c
+++ b/plugins/imfile/imfile.c
@@ -1482,1108 +1813,150 @@ CODESTARTfreeCnf
 ENDfreeCnf
 
 
-/* Monitor files in traditional polling mode.
- *
- * We go through all files and remember if at least one had data. If so, we do
- * another run (until no data was present in any file). Then we sleep for
- * PollInterval seconds and restart the whole process. This ensures that as
- * long as there is some data present, it will be processed at the fastest
- * possible pace - probably important for busy systmes. If we monitor just a
- * single file, the algorithm is slightly modified. In that case, the sleep
- * hapens immediately. The idea here is that if we have just one file, we
- * returned from the file processer because that file had no additional data.
- * So even if we found some lines, it is highly unlikely to find a new one
- * just now. Trying it would result in a performance-costly additional try
- * which in the very, very vast majority of cases will never find any new
- * lines.
- * On spamming the main queue: keep in mind that it will automatically rate-limit
- * ourselfes if we begin to overrun it. So we really do not need to care here.
- */
+/* Monitor files in polling mode. */
 static rsRetVal
 doPolling(void)
 {
-	int bHadFileData; /* were there at least one file with data during this run? */
 	DEFiRet;
 	while(glbl.GetGlobalInputTermState() == 0) {
+		DBGPRINTF("doPolling: new poll run\n");
 		do {
-			lstn_t *pLstn;
-			bHadFileData = 0;
-			for(pLstn = runModConf->pRootLstn ; pLstn != NULL ; pLstn = pLstn->next) {
-				if(glbl.GetGlobalInputTermState() == 1)
-					break; /* terminate input! */
-				pollFile(pLstn, &bHadFileData);
-			}
-		} while(bHadFileData == 1 && glbl.GetGlobalInputTermState() == 0);
-		  /* warning: do...while()! */
+			runModConf->bHadFileData = 0;
+			fs_node_walk(runModConf->conf_tree, poll_tree);
+			DBGPRINTF("doPolling: end poll walk, hadData %d\n", runModConf->bHadFileData);
+		} while(runModConf->bHadFileData); /* warning: do...while()! */
 
 		/* Note: the additional 10ns wait is vitally important. It guards rsyslog
 		 * against totally hogging the CPU if the users selects a polling interval
-		 * of 0 seconds. It doesn't hurt any other valid scenario. So do not remove.
-		 * rgerhards, 2008-02-14
-		 */
-		if(glbl.GetGlobalInputTermState() == 0)
-			srSleep(runModConf->iPollInterval, 10);
-	}
-
-	RETiRet;
-}
-
-//-------------------- NOW NEEDED for FEN as well!
-#if defined(HAVE_INOTIFY_INIT) || (defined(OS_SOLARIS) && defined (HAVE_PORT_SOURCE_FILE))
-/* the basedir buffer must be of size MAXFNAME
- * returns the index of the last slash before the basename
- */
-static int ATTR_NONNULL()
-getBasedir(uchar *const __restrict__ basedir, uchar *const __restrict__ path)
-{
-	int i;
-	int found = 0;
-	const int lenName = ustrlen(path);
-	for(i = lenName ; i >= 0 ; --i) {
-		if(path[i] == '/') {
-			/* found basename component */
-			found = 1;
-			if(i == lenName)
-				basedir[0] = '\0';
-			else {
-				memcpy(basedir, path, i);
-				basedir[i] = '\0';
-			}
-			break;
-		}
-	}
-	if (found == 1)
-		return i;
-	else {
-		return -1;
-	}
-}
-
-static rsRetVal ATTR_NONNULL()
-fileTableInit(fileTable_t *const __restrict__ tab, const int nelem)
-{
-	DEFiRet;
-	CHKmalloc(tab->listeners = malloc(sizeof(dirInfoFiles_t) * nelem));
-	tab->allocMax = nelem;
-	tab->currMax = 0;
-finalize_it:
-	RETiRet;
-}
-
-#if ULTRA_DEBUG == 1
-static void ATTR_NONNULL()
-fileTableDisplay(fileTable_t *tab)
-{
-	int f;
-	uchar *baseName;
-	DBGPRINTF("fileTableDisplay = dirs.currMaxfiles %d\n", tab->currMax);
-	for(f = 0 ; f < tab->currMax ; ++f) {
-		baseName = tab->listeners[f].pLstn->pszBaseName;
-		DBGPRINTF("fileTableDisplay = TABLE %p CONTENTS, %d->%p:'%s'\n",
-			tab, f, tab->listeners[f].pLstn, (char*)baseName);
-	}
-}
-#endif
-
-static int ATTR_NONNULL()
-fileTableSearch(fileTable_t *const __restrict__ tab, uchar *const __restrict__ fn)
-{
-	int f;
-	uchar *baseName = NULL;
-	#if ULTRA_DEBUG == 1
-		fileTableDisplay(tab);
-	#endif
-	for(f = 0 ; f < tab->currMax ; ++f) {
-		baseName = tab->listeners[f].pLstn->pszBaseName;
-		if(!fnmatch((char*)baseName, (char*)fn, FNM_PATHNAME | FNM_PERIOD))
-			break; /* found */
-	}
-	if(f == tab->currMax)
-		f = -1;
-	DBGPRINTF("fileTableSearch file '%s' - '%s', found:%d\n", fn, (f == -1) ? NULL : baseName, f);
-	return f;
-}
-
-static int ATTR_NONNULL()
-fileTableSearchNoWildcard(fileTable_t *const __restrict__ tab, uchar *const __restrict__ fn)
-{
-	int f;
-	uchar *baseName = NULL;
-	for(f = 0 ; f < tab->currMax ; ++f) {
-		baseName = tab->listeners[f].pLstn->pszBaseName;
-		if (strcmp((const char*)baseName, (const char*)fn) == 0)
-			break; /* found */
-	}
-	if(f == tab->currMax)
-		f = -1;
-	DBGPRINTF("fileTableSearchNoWildcard file '%s' - '%s', found:%d\n", fn, baseName, f);
-	return f;
-}
-
-/* add file to file table */
-static rsRetVal ATTR_NONNULL()
-fileTableAddFile(fileTable_t *const __restrict__ tab, lstn_t *const __restrict__ pLstn)
-{
-	int j;
-	DEFiRet;
-	for(j = 0 ; j < tab->currMax && tab->listeners[j].pLstn != pLstn ; ++j)
-		; /* just scan */
-	if(j < tab->currMax) {
-		++tab->listeners[j].refcnt;
-		DBGPRINTF("file '%s' already registered, refcnt now %d\n",
-			pLstn->pszFileName, tab->listeners[j].refcnt);
-		FINALIZE;
-	}
-
-	if(tab->currMax == tab->allocMax) {
-		const int newMax = 2 * tab->allocMax;
-		dirInfoFiles_t *newListenerTab = realloc(tab->listeners, newMax * sizeof(dirInfoFiles_t));
-		if(newListenerTab == NULL) {
-			LogError(0, RS_RET_OUT_OF_MEMORY,
-					"cannot alloc memory to map directory/file relationship "
-					"for '%s' - ignoring", pLstn->pszFileName);
-			ABORT_FINALIZE(RS_RET_OUT_OF_MEMORY);
-		}
-		tab->listeners = newListenerTab;
-		tab->allocMax = newMax;
-		DBGPRINTF("increased dir table to %d entries\n", allocMaxDirs);
-	}
-
-	tab->listeners[tab->currMax].pLstn = pLstn;
-	tab->listeners[tab->currMax].refcnt = 1;
-	tab->currMax++;
-finalize_it:
-	RETiRet;
-}
-
-/* delete a file from file table */
-static rsRetVal ATTR_NONNULL()
-fileTableDelFile(fileTable_t *const __restrict__ tab, lstn_t *const __restrict__ pLstn)
-{
-	int j;
-	DEFiRet;
-
-	for(j = 0 ; j < tab->currMax && tab->listeners[j].pLstn != pLstn ; ++j)
-		; /* just scan */
-	if(j == tab->currMax) {
-		DBGPRINTF("no association for file '%s'\n", pLstn->pszFileName);
-		FINALIZE;
-	}
-	tab->listeners[j].refcnt--;
-	if(tab->listeners[j].refcnt == 0) {
-		/* we remove that entry (but we never shrink the table) */
-		if(j < tab->currMax - 1) {
-			/* entry in middle - need to move others */
-			memmove(tab->listeners+j, tab->listeners+j+1,
-				(tab->currMax -j-1) * sizeof(dirInfoFiles_t));
-		}
-		--tab->currMax;
-	}
-finalize_it:
-	RETiRet;
-}
-
-/* add entry to dirs array */
-static rsRetVal
-dirsAdd(const uchar *const dirName, int *const piIndex)
-{
-	sbool sbAdded;
-	int newMax;
-	int i, newindex;
-	dirInfo_t *newDirTab;
-	char* psztmp;
-	DEFiRet;
-
-	dbgprintf("dirsAdd: add '%s'\n", dirName);
-	/* Set new index to last dir by default, then search for a free spot in dirs array */
-	newindex = currMaxDirs;
-	sbAdded = TRUE;
-	for(i= 0 ; i < currMaxDirs ; ++i) {
-		if (dirs[i].dirName == NULL) {
-			newindex = i;
-			sbAdded = FALSE;
-			DBGPRINTF("dirsAdd found free spot at %d, reusing\n", newindex);
-			break;
-		}
-	}
-
-	/* Save Index for higher functions */
-	if (piIndex != NULL )
-		*piIndex = newindex;
-
-	/* Check if dirstab size needs to be increased */
-	if(sbAdded == TRUE && newindex == allocMaxDirs) {
-		newMax = 2 * allocMaxDirs;
-		newDirTab = realloc(dirs, newMax * sizeof(dirInfo_t));
-		if(newDirTab == NULL) {
-			LogError(0, RS_RET_OUT_OF_MEMORY,
-					"dirsAdd cannot alloc memory to monitor directory '%s' - ignoring",
-					dirName);
-			ABORT_FINALIZE(RS_RET_OUT_OF_MEMORY);
-		}
-		dirs = newDirTab;
-		allocMaxDirs = newMax;
-		DBGPRINTF("dirsAdd increased dir table to %d entries\n", allocMaxDirs);
-	}
-
-	/* if we reach this point, there is space in the file table for the new entry */
-	CHKmalloc(dirs[newindex].dirName = ustrdup(dirName)); /* Get a copy of the string !*/
-	dirs[newindex].dirNameBfWildCard = NULL;
-	dirs[newindex].bDirType = DIR_CONFIGURED; /* Default to configured! */
-	CHKiRet(fileTableInit(&dirs[newindex].active, INIT_FILE_IN_DIR_TAB_SIZE));
-	CHKiRet(fileTableInit(&dirs[newindex].configured, INIT_FILE_IN_DIR_TAB_SIZE));
-
-	/* check for wildcard in directoryname, if last character is a wildcard we remove it and try again! */
-	dirs[newindex].hasWildcard = containsGlobWildcard((char*)dirName);
-	CHKmalloc(dirs[newindex].dirNameBfWildCard = ustrdup(dirName));
-
-	/* Default rootidx always -1 */
-	dirs[newindex].rdiridx = -1;
-
-	/* Extrac checking for wildcard mode */
-	if (dirs[newindex].hasWildcard) {
-		// TODO: wildcard is not necessarily in last char!!!
-		// TODO: BUG: we have many more wildcards that "*" - so this check is invalid
-		DBGPRINTF("dirsAdd detected wildcard in dir '%s'\n", dirName);
-
-		/* Set NULL Byte to FIRST wildcard occurrence */
-		psztmp = strchr((char*)dirs[newindex].dirNameBfWildCard, '*');
-		if (psztmp != NULL) {
-			*psztmp = '\0';
-			/*	Now set NULL Byte on last directory delimiter occurrence,
-			*	This makes sure that we have the current base path to create a watch for! */
-			psztmp = strrchr((char*)dirs[newindex].dirNameBfWildCard, '/');
-			if (psztmp != NULL) {
-				*psztmp = '\0';
-			} else {
-				LogError(0, RS_RET_SYS_ERR , "imfile: dirsAdd unexpected error #1 "
-					"for dir '%s' ", dirName);
-				ABORT_FINALIZE(RS_RET_SYS_ERR);
-			}
-		} else {
-			LogError(0, RS_RET_SYS_ERR , "imfile: dirsAdd unexpected error #2 "
-				"for dir '%s' ", dirName);
-			ABORT_FINALIZE(RS_RET_SYS_ERR);
-		}
-		DBGPRINTF("dirsAdd after wildcard removal: '%s'\n",
-			dirs[newindex].dirNameBfWildCard);
-	}
-
-#if defined(OS_SOLARIS) && defined (HAVE_PORT_SOURCE_FILE)
-	// Create FileInfo struct
-	dirs[newindex].pfinf = malloc(sizeof(struct fileinfo));
-	if (dirs[newindex].pfinf == NULL) {
-		LogError(0, RS_RET_OUT_OF_MEMORY, "imfile: dirsAdd alloc memory "
-			"for fileinfo failed ");
-		ABORT_FINALIZE(RS_RET_OUT_OF_MEMORY);
-	}
-	/* Use parent dir on Wildcard pathes */
-	if (dirs[newindex].hasWildcard) {
-		if ((dirs[newindex].pfinf->fobj.fo_name = strdup((char*)dirs[newindex].dirNameBfWildCard)) == NULL) {
-			LogError(0, RS_RET_OUT_OF_MEMORY, "imfile: dirsAdd alloc memory "
-				"for strdup failed ");
-			free(dirs[newindex].pfinf);
-			dirs[newindex].pfinf = NULL;
-			ABORT_FINALIZE(RS_RET_OUT_OF_MEMORY);
-		}
-
-	} else {
-		if ((dirs[newindex].pfinf->fobj.fo_name = strdup((char*)dirs[newindex].dirName)) == NULL) {
-			LogError(0, RS_RET_OUT_OF_MEMORY, "imfile: dirsAdd alloc memory "
-				"for strdup failed ");
-			free(dirs[newindex].pfinf);
-			dirs[newindex].pfinf = NULL;
-			ABORT_FINALIZE(RS_RET_OUT_OF_MEMORY);
-		}
-	}
-
-	/* Event types to watch. */
-	dirs[newindex].pfinf->events = FILE_MODIFIED; // |FILE_DELETE|FILE_RENAME_TO|FILE_RENAME_FROM;
-	dirs[newindex].pfinf->port = glport;
-	dirs[newindex].bPortAssociated = 0;
-#endif
-
-	DBGPRINTF("dirsAdd added dir %d to dirs table: '%s'\n", newindex, dirName);
-	/* Increment only if entry was added and not reused */
-	if (sbAdded == TRUE)
-		++currMaxDirs;
-finalize_it:
-	RETiRet;
-}
-
-
-/* checks if a dir name is already inside the dirs array. If so, returns
- * its index. If not present, -1 is returned.
- */
-static int ATTR_NONNULL(1)
-dirsFindDir(const uchar *const dir)
-{
-	int i;
-	int iFind = -1;
-
-	for(i = 0 ; i < currMaxDirs ; ++i) {
-		if (dirs[i].dirName != NULL && ustrcmp(dir, dirs[i].dirName) == 0) {
-			iFind = i;
-			break;
-		}
-	}
-	DBGPRINTF("dirsFindDir: '%s' - idx %d\n", dir, iFind);
-	return iFind;
-}
-
-static rsRetVal
-dirsInit(void)
-{
-	instanceConf_t *inst;
-	DEFiRet;
-
-DBGPRINTF("dirsInit\n");
-	free(dirs);
-	CHKmalloc(dirs = malloc(sizeof(dirInfo_t) * INIT_FILE_TAB_SIZE));
-	allocMaxDirs = INIT_FILE_TAB_SIZE;
-	currMaxDirs = 0;
-
-	for(inst = runModConf->root ; inst != NULL ; inst = inst->next) {
-		if(dirsFindDir(inst->pszDirName) == -1)
-			dirsAdd(inst->pszDirName, NULL);
-	}
-
-finalize_it:
-	RETiRet;
-}
-
-/* add file to directory (create association)
- * fIdx is index into file table, all other information is pulled from that table.
- * bActive is 1 if the file is to be added to active set, else zero
- */
-static rsRetVal ATTR_NONNULL(1)
-dirsAddFile(lstn_t *__restrict__ pLstn, const int bActive)
-{
-	int dirIdx;
-	dirInfo_t *dir;
-	DEFiRet;
-
-	dirIdx = dirsFindDir(pLstn->pszDirName);
-	if(dirIdx == -1) {
-		LogError(0, RS_RET_INTERNAL_ERROR, "imfile: could not find "
-			"directory '%s' in dirs array - ignoring",
-			pLstn->pszDirName);
-		FINALIZE;
-	}
-
-	dir = dirs + dirIdx;
-	CHKiRet(fileTableAddFile((bActive ? &dir->active : &dir->configured), pLstn));
-	DBGPRINTF("associated file [%s] to directory %d[%s], Active = %d\n",
-		pLstn->pszFileName, dirIdx, dir->dirName, bActive);
-	#if ULTRA_DEBUG == 1
-	/* UNCOMMENT FOR DEBUG fileTableDisplay(bActive ? &dir->active : &dir->configured); */
-	#endif
-finalize_it:
-	RETiRet;
-}
-
-/* Duplicate an existing listener. This is called when a new file is to
- * be monitored due to wildcard detection. Returns the new pLstn in
- * the ppExisting parameter.
- */
-static rsRetVal ATTR_NONNULL(1, 2)
-lstnDup(lstn_t ** ppExisting,
-	const uchar *const __restrict__ newname,
-	const uchar *const __restrict__ newdirname)
-{
-	DEFiRet;
-	lstn_t *const existing = *ppExisting;
-	lstn_t *pThis;
-	CHKiRet(lstnAdd(&pThis));
-
-	/* Use dynamic dirname if newdirname is set! */
-	if (newdirname == NULL) {
-		pThis->pszDirName = existing->pszDirName; /* read-only */
-	} else {
-		CHKmalloc(pThis->pszDirName = ustrdup(newdirname));
-	}
-	CHKmalloc(pThis->pszBaseName = ustrdup(newname));
-	if(asprintf((char**)&pThis->pszFileName, "%s/%s",
-		(char*)pThis->pszDirName, (char*)newname) == -1) {
-		DBGPRINTF("lstnDup: asprintf failed, malfunction can happen\n");
-		ABORT_FINALIZE(RS_RET_OUT_OF_MEMORY);
-	}
-	CHKmalloc(pThis->pszTag = ustrdup(existing->pszTag));
-	pThis->lenTag = ustrlen(pThis->pszTag);
-	if(existing->pszStateFile == NULL) {
-		pThis->pszStateFile = NULL;
-	} else {
-		CHKmalloc(pThis->pszStateFile = ustrdup(existing->pszStateFile));
-	}
-
-	CHKiRet(ratelimitNew(&pThis->ratelimiter, "imfile", (char*)pThis->pszFileName));
-	pThis->multiSub.maxElem = existing->multiSub.maxElem;
-	pThis->multiSub.nElem = 0;
-	CHKmalloc(pThis->multiSub.ppMsgs = MALLOC(pThis->multiSub.maxElem * sizeof(smsg_t*)));
-	pThis->iSeverity = existing->iSeverity;
-	pThis->iFacility = existing->iFacility;
-	pThis->maxLinesAtOnce = existing->maxLinesAtOnce;
-	pThis->trimLineOverBytes = existing->trimLineOverBytes;
-	pThis->iPersistStateInterval = existing->iPersistStateInterval;
-	pThis->readMode = existing->readMode;
-	pThis->startRegex = existing->startRegex; /* no strdup, as it is read-only */
-	if(pThis->startRegex != NULL) // TODO: make this a single function with better error handling
-		if(regcomp(&pThis->end_preg, (char*)pThis->startRegex, REG_EXTENDED)) {
-			DBGPRINTF("error regex compile\n");
-			ABORT_FINALIZE(RS_RET_ERR);
-		}
-	pThis->discardTruncatedMsg = existing->discardTruncatedMsg;
-	pThis->msgDiscardingError = existing->msgDiscardingError;
-	pThis->bRMStateOnDel = existing->bRMStateOnDel;
-	pThis->hasWildcard = existing->hasWildcard;
-	pThis->escapeLF = existing->escapeLF;
-	pThis->reopenOnTruncate = existing->reopenOnTruncate;
-	pThis->addMetadata = existing->addMetadata;
-	pThis->addCeeTag = existing->addCeeTag;
-	pThis->readTimeout = existing->readTimeout;
-	pThis->freshStartTail = existing->freshStartTail;
-	pThis->fileNotFoundError = existing->fileNotFoundError;
-	pThis->pRuleset = existing->pRuleset;
-	pThis->nRecords = 0;
-	pThis->pStrm = NULL;
-	pThis->prevLineSegment = NULL;
-	pThis->masterLstn = existing;
-	#ifdef HAVE_INOTIFY_INIT
-		pThis->movedfrom_statefile = NULL;
-		pThis->movedfrom_cookie = 0;
-	#endif
-	#if defined(OS_SOLARIS) && defined (HAVE_PORT_SOURCE_FILE)
-		pThis->pfinf = NULL;
-		pThis->bPortAssociated = 0;
-	#endif
-	*ppExisting = pThis;
-finalize_it:
-	RETiRet;
-}
-#endif /* #if defined(HAVE_INOTIFY_INIT) || (defined(OS_SOLARIS) && defined (HAVE_PORT_SOURCE_FILE)) --- */
-
-#ifdef HAVE_INOTIFY_INIT
-static void
-in_setupDirWatch(const int dirIdx)
-{
-	const int wd = inotify_add_watch(ino_fd, (char*)dirs[dirIdx].dirNameBfWildCard,
-		IN_CREATE|IN_DELETE|IN_MOVED_FROM|IN_MOVED_TO);
-	if(wd < 0) {
-		LogError(errno, RS_RET_IO_ERROR, "imfile: cannot watch directory '%s'",
-			dirs[dirIdx].dirNameBfWildCard);
-		goto done;
-	}
-	wdmapAdd(wd, dirIdx, NULL);
-	DBGPRINTF("in_setupDirWatch: watch %d added for dir %s(Idx=%d)\n", wd,
-		(char*) dirs[dirIdx].dirNameBfWildCard, dirIdx);
-done:	return;
-}
-
-/* Setup a new file watch for a known active file. It must already have
- * been entered into the correct tables.
- * Note: we need to try to read this file, as it may already contain data this
- * needs to be processed, and we won't get an event for that as notifications
- * happen only for things after the watch has been activated.
- * Note: newFileName is NULL for configured files, and non-NULL for dynamically
- * detected files (e.g. wildcards!)
- */
-static void ATTR_NONNULL(1)
-startLstnFile(lstn_t *const __restrict__ pLstn)
-{
-	rsRetVal localRet;
-	DBGPRINTF("startLstnFile for file '%s'\n", pLstn->pszFileName);
-	const int wd = inotify_add_watch(ino_fd, (char*)pLstn->pszFileName, IN_MODIFY);
-	if(wd < 0) {
-		if(pLstn->fileNotFoundError) {
-			LogError(errno, NO_ERRCODE, "imfile: error with inotify API,"
-					" ignoring file '%s'", pLstn->pszFileName);
-		} else {
-			char errStr[512];
-			rs_strerror_r(errno, errStr, sizeof(errStr));
-			DBGPRINTF("could not create file table entry for '%s' - "
-				  "not processing it now: %s\n", pLstn->pszFileName, errStr);
-		}
-		goto done;
-	}
-	if((localRet = wdmapAdd(wd, -1, pLstn)) != RS_RET_OK) {
-		if(	localRet != RS_RET_FILE_ALREADY_IN_TABLE &&
-			pLstn->fileNotFoundError) {
-			LogError(0, NO_ERRCODE, "imfile: internal error: error %d adding file "
-					"to wdmap, ignoring file '%s'\n", localRet, pLstn->pszFileName);
-		} else {
-			DBGPRINTF("error %d adding file to wdmap, ignoring\n", localRet);
-		}
-		goto done;
-	}
-	DBGPRINTF("watch %d added for file %s\n", wd, pLstn->pszFileName);
-	dirsAddFile(pLstn, ACTIVE_FILE);
-	pollFile(pLstn, NULL);
-done:	return;
-}
-
-/* Setup a new file watch for dynamically discovered files (via wildcards).
- * Note: we need to try to read this file, as it may already contain data this
- * needs to be processed, and we won't get an event for that as notifications
- * happen only for things after the watch has been activated.
- */
-static void ATTR_NONNULL(1)
-in_setupFileWatchDynamic(lstn_t *pLstn,
-	uchar *const __restrict__ newBaseName,
-	uchar *const __restrict__ newFileName)
-{
-	char fullfn[MAXFNAME];
-	struct stat fileInfo;
-	uchar basedir[MAXFNAME];
-	uchar* pBaseDir = NULL;
-	int idirindex;
-
-	if (newFileName == NULL) {
-		snprintf(fullfn, MAXFNAME, "%s/%s", pLstn->pszDirName, newBaseName);
-	} else {
-		/* Get BaseDir from filename! */
-		getBasedir(basedir, newFileName);
-		pBaseDir = &basedir[0]; /* Set BaseDir Pointer */
-		idirindex = dirsFindDir(basedir);
-		if (idirindex == -1) {
-			/* Add dir to table and create watch */
-			DBGPRINTF("Adding new dir '%s' to dirs table \n", basedir);
-			dirsAdd(basedir, &idirindex);
-			in_setupDirWatch(idirindex);
-		}
-		/* Use newFileName */
-		snprintf(fullfn, MAXFNAME, "%s", newFileName);
-	}
-	if(stat(fullfn, &fileInfo) != 0) {
-		char errStr[1024];
-		rs_strerror_r(errno, errStr, sizeof(errStr));
-		DBGPRINTF("ignoring file '%s' cannot stat(): %s\n",
-			fullfn, errStr);
-		goto done;
-	}
-
-	if(S_ISDIR(fileInfo.st_mode)) {
-		DBGPRINTF("ignoring directory '%s'\n", fullfn);
-		goto done;
-	}
-
-	if(lstnDup(&pLstn, newBaseName, pBaseDir) != RS_RET_OK)
-		goto done;
-
-	startLstnFile(pLstn);
-done:	return;
-}
-
-/* Search for matching files using glob.
- * Create Dynamic Watch for each found file
- */
-static void
-in_setupFileWatchGlobSearch(lstn_t *pLstn)
-{
-	int wd;
-
-	DBGPRINTF("in_setupFileWatchGlobSearch file '%s' has wildcard, doing initial expansion\n",
-		pLstn->pszFileName);
-	glob_t files;
-	const int ret = glob((char*)pLstn->pszFileName,
-				GLOB_MARK|GLOB_NOSORT|GLOB_BRACE, NULL, &files);
-	if(ret == 0) {
-		for(unsigned i = 0 ; i < files.gl_pathc ; i++) {
-			uchar basen[MAXFNAME];
-			uchar *const file = (uchar*)files.gl_pathv[i];
-
-			if(file[strlen((char*)file)-1] == '/')
-				continue;/* we cannot process subdirs! */
-
-			/* search for existing watched files !*/
-			wd = wdmapLookupFilename(file);
-			if(wd >= 0) {
-				DBGPRINTF("in_setupFileWatchGlobSearch '%s' already watched in wd %d\n",
-					file, wd);
-			} else {
-				getBasename(basen, file);
-				DBGPRINTF("in_setupFileWatchGlobSearch setup dynamic watch "
-					"for '%s : %s' \n", basen, file);
-				in_setupFileWatchDynamic(pLstn, basen, file);
-			}
-		}
-		globfree(&files);
-	}
-}
-
-/* Setup a new file watch for static (configured) files.
- * Note: we need to try to read this file, as it may already contain data this
- * needs to be processed, and we won't get an event for that as notifications
- * happen only for things after the watch has been activated.
- */
-static void ATTR_NONNULL(1)
-in_setupFileWatchStatic(lstn_t *pLstn)
-{
-	sbool hasWildcard;
-
-	DBGPRINTF("in_setupFileWatchStatic: adding file '%s' to configured table\n",
-		  pLstn->pszFileName);
-	dirsAddFile(pLstn, CONFIGURED_FILE);
-
-	/* perform wildcard check on static files manually */
-	hasWildcard = containsGlobWildcard((char*)pLstn->pszFileName);
-	if(hasWildcard) {
-		/* search for matching files */
-		in_setupFileWatchGlobSearch(pLstn);
-	} else {
-		/* Duplicate static object as well, otherwise the configobject
-		 * could be deleted later! */
-		if(lstnDup(&pLstn, pLstn->pszBaseName, NULL) != RS_RET_OK) {
-			DBGPRINTF("in_setupFileWatchStatic failed to duplicate listener for '%s'\n",
-				pLstn->pszFileName);
-			goto done;
-		}
-		startLstnFile(pLstn);
-	}
-done:	return;
-}
-
-/* setup our initial set of watches, based on user config */
-static void
-in_setupInitialWatches(void)
-{
-	int i;
-	DBGPRINTF("setting up initial directory watches\n");
-	for(i = 0 ; i < currMaxDirs ; ++i) {
-		in_setupDirWatch(i);
-	}
-	lstn_t *pLstn;
-	DBGPRINTF("setting up initial listener watches\n");
-	for(pLstn = runModConf->pRootLstn ; pLstn != NULL ; pLstn = pLstn->next) {
-		if(pLstn->masterLstn == NULL) {
-			/* we process only static (master) entries */
-			in_setupFileWatchStatic(pLstn);
-		}
+		 * of 0 seconds. It doesn't hurt any other valid scenario. So do not remove.
+		 * rgerhards, 2008-02-14
+		 */
+		DBGPRINTF("doPolling: poll going to sleep\n");
+		if(glbl.GetGlobalInputTermState() == 0)
+			srSleep(runModConf->iPollInterval, 10);
 	}
+
+	RETiRet;
 }
 
+#if defined(HAVE_INOTIFY_INIT)
+
 static void ATTR_NONNULL(1)
-in_dbg_showEv(struct inotify_event *ev)
+in_dbg_showEv(const struct inotify_event *ev)
 {
 	if(!Debug)
 		return;
 	if(ev->mask & IN_IGNORED) {
 		dbgprintf("INOTIFY event: watch was REMOVED\n");
-	} else if(ev->mask & IN_MODIFY) {
+	}
+	if(ev->mask & IN_MODIFY) {
 		dbgprintf("INOTIFY event: watch was MODIFID\n");
-	} else if(ev->mask & IN_ACCESS) {
+	}
+	if(ev->mask & IN_ACCESS) {
 		dbgprintf("INOTIFY event: watch IN_ACCESS\n");
-	} else if(ev->mask & IN_ATTRIB) {
+	}
+	if(ev->mask & IN_ATTRIB) {
 		dbgprintf("INOTIFY event: watch IN_ATTRIB\n");
-	} else if(ev->mask & IN_CLOSE_WRITE) {
+	}
+	if(ev->mask & IN_CLOSE_WRITE) {
 		dbgprintf("INOTIFY event: watch IN_CLOSE_WRITE\n");
-	} else if(ev->mask & IN_CLOSE_NOWRITE) {
+	}
+	if(ev->mask & IN_CLOSE_NOWRITE) {
 		dbgprintf("INOTIFY event: watch IN_CLOSE_NOWRITE\n");
-	} else if(ev->mask & IN_CREATE) {
+	}
+	if(ev->mask & IN_CREATE) {
 		dbgprintf("INOTIFY event: file was CREATED: %s\n", ev->name);
-	} else if(ev->mask & IN_DELETE) {
+	}
+	if(ev->mask & IN_DELETE) {
 		dbgprintf("INOTIFY event: watch IN_DELETE\n");
-	} else if(ev->mask & IN_DELETE_SELF) {
+	}
+	if(ev->mask & IN_DELETE_SELF) {
 		dbgprintf("INOTIFY event: watch IN_DELETE_SELF\n");
-	} else if(ev->mask & IN_MOVE_SELF) {
+	}
+	if(ev->mask & IN_MOVE_SELF) {
 		dbgprintf("INOTIFY event: watch IN_MOVE_SELF\n");
-	} else if(ev->mask & IN_MOVED_FROM) {
-		dbgprintf("INOTIFY event: watch IN_MOVED_FROM\n");
-	} else if(ev->mask & IN_MOVED_TO) {
-		dbgprintf("INOTIFY event: watch IN_MOVED_TO\n");
-	} else if(ev->mask & IN_OPEN) {
+	}
+	if(ev->mask & IN_MOVED_FROM) {
+		dbgprintf("INOTIFY event: watch IN_MOVED_FROM, cookie %u, name '%s'\n", ev->cookie, ev->name);
+	}
+	if(ev->mask & IN_MOVED_TO) {
+		dbgprintf("INOTIFY event: watch IN_MOVED_TO, cookie %u, name '%s'\n", ev->cookie, ev->name);
+	}
+	if(ev->mask & IN_OPEN) {
 		dbgprintf("INOTIFY event: watch IN_OPEN\n");
-	} else if(ev->mask & IN_ISDIR) {
+	}
+	if(ev->mask & IN_ISDIR) {
 		dbgprintf("INOTIFY event: watch IN_ISDIR\n");
-	} else {
-		dbgprintf("INOTIFY event: unknown mask code %8.8x\n", ev->mask);
-	 }
-}
-
-/* Helper function to get fullpath when handling inotify dir events */
-static void ATTR_NONNULL()
-in_handleDirGetFullDir(char *const pszoutput, const int dirIdx, const char *const pszsubdir)
-{
-	assert(dirIdx >= 0);
-	DBGPRINTF("in_handleDirGetFullDir root='%s' sub='%s' \n", dirs[dirIdx].dirName, pszsubdir);
-	snprintf(pszoutput, MAXFNAME, "%s/%s", dirs[dirIdx].dirNameBfWildCard, pszsubdir);
-}
-
-/* inotify told us that a file's wd was closed. We now need to remove
- * the file from our internal structures. Remember that a different inode
- * with the same name may already be in processing.
- */
-static void ATTR_NONNULL(2)
-in_removeFile(const int dirIdx, lstn_t *const __restrict__ pLstn, const sbool bRemoveStateFile)
-{
-	uchar statefile[MAXFNAME];
-	uchar toDel[MAXFNAME];
-	int bDoRMState;
-	int wd;
-	uchar *statefn;
-
-	DBGPRINTF("remove listener '%s', dirIdx %d\n", pLstn->pszFileName, dirIdx);
-	if(bRemoveStateFile == TRUE && pLstn->bRMStateOnDel) {
-		statefn = getStateFileName(pLstn, statefile, sizeof(statefile), NULL);
-		/* Get full path and file name */
-		getFullStateFileName(statefn, toDel, sizeof(toDel));
-		bDoRMState = 1;
-	} else {
-		bDoRMState = 0;
-	}
-	pollFile(pLstn, NULL); /* one final try to gather data */
-	/* delete listener data */
-	DBGPRINTF("DELETING listener data for '%s' - '%s'\n", pLstn->pszBaseName, pLstn->pszFileName);
-	lstnDel(pLstn);
-	fileTableDelFile(&dirs[dirIdx].active, pLstn);
-	if(bDoRMState) {
-		DBGPRINTF("unlinking '%s'\n", toDel);
-		if(unlink((char*)toDel) != 0) {
-			LogError(errno, RS_RET_ERR, "imfile: could not remove state "
-				"file '%s'", toDel);
-		}
 	}
-
-	wd = wdmapLookupListner(pLstn);
-	wdmapDel(wd);
 }
 
-static void ATTR_NONNULL(1)
-in_handleDirEventDirCREATE(struct inotify_event *ev, const int dirIdx)
-{
-	char fulldn[MAXFNAME];
-	int newdiridx;
-	int iListIdx;
-	sbool hasWildcard;
-
-	/* Combine to Full Path first */
-	in_handleDirGetFullDir(fulldn, dirIdx, (char*)ev->name);
-
-	/* Search for existing entry first! */
-	newdiridx = dirsFindDir( (uchar*)fulldn );
-	if(newdiridx == -1) {
-		/* Add dir to table and create watch */
-		DBGPRINTF("in_handleDirEventDirCREATE Adding new dir '%s' to dirs table \n", fulldn);
-		dirsAdd((uchar*)fulldn, &newdiridx);
-		dirs[newdiridx].bDirType = DIR_DYNAMIC; /* Set to DYNAMIC directory! */
-		in_setupDirWatch(newdiridx);
-		/* Set propper root index for newdiridx */
-		dirs[newdiridx].rdiridx = (dirs[dirIdx].rdiridx != -1 ? dirs[dirIdx].rdiridx : dirIdx);
-
-		DBGPRINTF("in_handleDirEventDirCREATE wdentry dirIdx=%d, rdirIdx=%d, dirIdxName=%s, dir=%s)\n",
-			dirIdx, dirs[newdiridx].rdiridx, dirs[dirIdx].dirName, fulldn);
-		if (dirs[dirs[newdiridx].rdiridx].configured.currMax > 0) {
-			DBGPRINTF("in_handleDirEventDirCREATE found configured listeners\n");
-
-			/* Loop through configured Listeners and scan for dynamic files */
-			for(iListIdx = 0; iListIdx < dirs[dirs[newdiridx].rdiridx].configured.currMax; iListIdx++) {
-				hasWildcard = (	dirs[dirs[newdiridx].rdiridx].hasWildcard ||
-					dirs[dirs[newdiridx].rdiridx].configured.listeners[iListIdx].pLstn->hasWildcard
-						? TRUE : FALSE);
-				if (hasWildcard == 1){
-					DBGPRINTF("in_handleDirEventDirCREATE configured listener has Wildcard\n");
-					/* search for matching files */
-					in_setupFileWatchGlobSearch(
-						dirs[dirs[newdiridx].rdiridx].configured.listeners[iListIdx].pLstn);
-				}
-			}
-		}
-	} else {
-		DBGPRINTF("dir '%s' already exists in dirs table (Idx %d)\n", fulldn, newdiridx);
-	}
-}
 
-static void ATTR_NONNULL(1)
-in_handleDirEventFileCREATE(struct inotify_event *const ev, const int dirIdx)
+static void ATTR_NONNULL(1, 2)
+in_handleFileEvent(struct inotify_event *ev, const wd_map_t *const etry)
 {
-	int i;
-	lstn_t *pLstn = NULL;
-	int ftIdx;
-	char fullfn[MAXFNAME];
-	uchar statefile_new[MAXFNAME];
-	uchar statefilefull_old[MAXFNAME];
-	uchar statefilefull_new[MAXFNAME];
-	uchar* pszDir = NULL;
-	int dirIdxFinal = dirIdx;
-	ftIdx = fileTableSearch(&dirs[dirIdxFinal].active, (uchar*)ev->name);
-	if(ftIdx >= 0) {
-		pLstn = dirs[dirIdxFinal].active.listeners[ftIdx].pLstn;
+	if(ev->mask & IN_MODIFY) {
+		DBGPRINTF("fs_node_notify_file_update: act->name '%s'\n", etry->act->name);
+		pollFile(etry->act);
 	} else {
-		DBGPRINTF("in_handleDirEventFileCREATE  '%s' not associated with dir '%s' "
-			"(CurMax:%d, DirIdx:%d, DirType:%s)\n", ev->name, dirs[dirIdxFinal].dirName,
-			dirs[dirIdxFinal].active.currMax, dirIdxFinal,
-			(dirs[dirIdxFinal].bDirType == DIR_CONFIGURED ? "configured" : "dynamic") );
-		ftIdx = fileTableSearch(&dirs[dirIdxFinal].configured, (uchar*)ev->name);
-		if(ftIdx == -1) {
-			if (dirs[dirIdxFinal].bDirType == DIR_DYNAMIC) {
-				/* Search all other configured directories for proper index! */
-				if (currMaxDirs > 0) {
-					/* Store Dirname as we need to overwrite it in in_setupFileWatchDynamic */
-					pszDir = dirs[dirIdxFinal].dirName;
-
-					/* Combine directory and filename */
-					snprintf(fullfn, MAXFNAME, "%s/%s", pszDir, (uchar*)ev->name);
-
-					for(i = 0 ; i < currMaxDirs ; ++i) {
-						ftIdx = fileTableSearch(&dirs[i].configured, (uchar*)ev->name);
-						if(ftIdx != -1) {
-							/* Found matching directory! */
-							dirIdxFinal = i; /* Have to correct directory index for
-							listnr dupl in in_setupFileWatchDynamic */
-
-							DBGPRINTF("Found matching directory for file '%s' in "
-								"dir '%s' (Idx=%d)\n", ev->name,
-								dirs[dirIdxFinal].dirName, dirIdxFinal);
-							break;
-						}
-					}
-					/* Found Listener to se */
-					pLstn = dirs[dirIdxFinal].configured.listeners[ftIdx].pLstn;
-
-					if(ftIdx == -1) {
-						DBGPRINTF("file '%s' not associated with dir '%s' and also no "
-							"matching wildcard directory found\n", ev->name,
-							dirs[dirIdxFinal].dirName);
-						goto done;
-					}
-					else {
-						DBGPRINTF("file '%s' not associated with dir '%s', using "
-							"dirIndex %d instead\n", ev->name, (pszDir == NULL)
-							? dirs[dirIdxFinal].dirName : pszDir, dirIdxFinal);
-					}
-				} else {
-					DBGPRINTF("file '%s' not associated with dir '%s'\n",
-						ev->name, dirs[dirIdxFinal].dirName);
-					goto done;
-				}
-			}
-		} else
-			pLstn = dirs[dirIdxFinal].configured.listeners[ftIdx].pLstn;
-	}
-	if (pLstn != NULL)	{
-		DBGPRINTF("file '%s' associated with dir '%s' (Idx=%d)\n",
-			ev->name, (pszDir == NULL) ? dirs[dirIdxFinal].dirName : pszDir, dirIdxFinal);
-
-		/* We need to check if we have a preexisting statefile and move it*/
-		if(ev->mask & IN_MOVED_TO) {
-			if (pLstn->movedfrom_statefile != NULL && pLstn->movedfrom_cookie == ev->cookie) {
-				/* We need to prepar fullfn before we can generate statefilename */
-				snprintf(fullfn, MAXFNAME, "%s/%s", (pszDir == NULL) ? dirs[dirIdxFinal].dirName
-					: pszDir, (uchar*)ev->name);
-				getStateFileName(NULL, statefile_new, sizeof(statefile_new), (uchar*)fullfn);
-				getFullStateFileName(statefile_new, statefilefull_new, sizeof(statefilefull_new));
-				getFullStateFileName(pLstn->movedfrom_statefile, statefilefull_old,
-					sizeof(statefilefull_old));
-
-				DBGPRINTF("old statefile '%s' needs to be moved to '%s' first!\n",
-				statefilefull_old, statefilefull_new);
-
-//				openStateFileAndMigrate(pLstn, &statefilefull_old[0], &statefilefull_new[0]);
-				if(rename((char*) &statefilefull_old, (char*) &statefilefull_new) != 0) {
-					LogError(errno, RS_RET_ERR, "imfile: could not rename statefile "
-						"'%s' into '%s'", statefilefull_old, statefilefull_new);
-				} else {
-					DBGPRINTF("statefile '%s' renamed into '%s'\n", statefilefull_old,
-						statefilefull_new);
-				}
-
-				/* Free statefile memory */
-				free(pLstn->movedfrom_statefile);
-				pLstn->movedfrom_statefile = NULL;
-				pLstn->movedfrom_cookie = 0;
-			} else {
-					DBGPRINTF("IN_MOVED_TO either unknown cookie '%d' we expected '%d' or "
-						"missing statefile '%s'\n", pLstn->movedfrom_cookie,
-						ev->cookie, pLstn->movedfrom_statefile);
-			}
-		}
-
-		/* Setup a watch now for new file*/
-		in_setupFileWatchDynamic(pLstn, (uchar*)ev->name, (pszDir == NULL) ? NULL : (uchar*)fullfn);
+		DBGPRINTF("got non-expected inotify event:\n");
+		in_dbg_showEv(ev);
 	}
-done:	return;
 }
 
-/* note: we need to care only for active files in the DELETE case.
- * Two reasons: a) if this is a configured file, it should be active
- * b) if not for some reason, there still is nothing we can do against
- * it, and trying to process a *deleted* file really makes no sense
- * (remeber we don't have it open, so it actually *is gone*).
- */
-static void ATTR_NONNULL(1)
-in_handleDirEventFileDELETE(struct inotify_event *const ev, const int dirIdx)
-{
-	const int ftIdx = fileTableSearch(&dirs[dirIdx].active, (uchar*)ev->name);
-	if(ftIdx == -1) {
-		DBGPRINTF("deleted file '%s' not active in dir '%s'\n",
-			ev->name, dirs[dirIdx].dirName);
-		goto done;
-	}
-	DBGPRINTF("imfile delete processing for '%s'\n",
-		dirs[dirIdx].active.listeners[ftIdx].pLstn->pszFileName);
-	in_removeFile(dirIdx, dirs[dirIdx].active.listeners[ftIdx].pLstn, TRUE);
-done:	return;
-}
 
-/* inotify told us that a dirs's wd was closed. We now need to remove
- * the dir from our internal structures.
+/* workaround for IN_MOVED: walk active list and prevent state file deletion of
+ * IN_MOVED_IN active object
+ * TODO: replace by a more generic solution.
  */
 static void
-in_removeDir(const int dirIdx)
-{
-	int wd;
-	wd = wdmapLookupListnerIdx(dirIdx);
-	DBGPRINTF("in_removeDir remove '%s', dirIdx=%d wdindex=%d\n", dirs[dirIdx].dirName, dirIdx, wd);
-	wdmapDel(wd);
-}
-
-static void ATTR_NONNULL(1)
-in_handleDirEventDirDELETE(struct inotify_event *const ev, const int dirIdx)
+flag_in_move(fs_edge_t *const edge, const char *name_moved)
 {
-	char fulldn[MAXFNAME];
-	int finddiridx;
-
-	in_handleDirGetFullDir(fulldn, dirIdx, (char*)ev->name);
+	act_obj_t *act;
 
-	/* Search for existing entry first! */
-	finddiridx = dirsFindDir( (uchar*)fulldn );
-
-	if(finddiridx != -1) {
-		/* Remove internal structures */
-		in_removeDir(finddiridx);
-
-		/* Delete dir from dirs array! */
-		free(dirs[finddiridx].dirName);
-		if (dirs[finddiridx].dirNameBfWildCard != NULL)
-			free(dirs[finddiridx].dirNameBfWildCard);
-		free(dirs[finddiridx].active.listeners);
-		free(dirs[finddiridx].configured.listeners);
-		dirs[finddiridx].dirName = NULL;
-		dirs[finddiridx].dirNameBfWildCard = NULL;
-
-		DBGPRINTF("in_handleDirEventDirDELETE dir (idx %d) '%s' deleted \n", finddiridx, fulldn);
-	} else {
-		DBGPRINTF("in_handleDirEventDirDELETE ERROR could not found '%s' in dirs table!\n", fulldn);
-	}
-}
-
-static void ATTR_NONNULL(1)
-in_handleDirEvent(struct inotify_event *const ev, const int dirIdx)
-{
-	DBGPRINTF("in_handleDirEvent dir event for (Idx %d)%s (mask %x)\n",
-		dirIdx, dirs[dirIdx].dirName, ev->mask);
-	if((ev->mask & IN_CREATE)) {
-		/* TODO: does IN_MOVED_TO make sense here ? */
-		if((ev->mask & IN_ISDIR) || (ev->mask & IN_MOVED_TO)) {
-			in_handleDirEventDirCREATE(ev, dirIdx); /* Create new Dir */
-		} else {
-			in_handleDirEventFileCREATE(ev, dirIdx); /* Create new File */
-		}
-	} else if((ev->mask & IN_DELETE)) {
-		if((ev->mask & IN_ISDIR)) {
-			in_handleDirEventDirDELETE(ev, dirIdx);	/* Create new Dir */
-		} else {
-			in_handleDirEventFileDELETE(ev, dirIdx);/* Delete File from dir filetable */
-		}
-	} else if((ev->mask & IN_MOVED_TO)) {
-		if((ev->mask & IN_ISDIR)) {
-			in_handleDirEventDirCREATE(ev, dirIdx); /* Create new Dir */
+	for(act = edge->active ; act != NULL ; act = act->next) {
+		DBGPRINTF("checking active object %s\n", act->basename);
+		if(!strcmp(act->basename, name_moved)){
+			DBGPRINTF("found file\n");
+			act->in_move = 1;
+			break;
 		} else {
-			in_handleDirEventFileCREATE(ev, dirIdx); /* Create new File */
+			DBGPRINTF("name check fails, '%s' != '%s'\n", act->basename, name_moved);
 		}
-	} else {
-		DBGPRINTF("got non-expected inotify event:\n");
-		in_dbg_showEv(ev);
-	}
-}
-
-
-static void ATTR_NONNULL(1, 2)
-in_handleFileEvent(struct inotify_event *ev, const wd_map_t *const etry)
-{
-	if(ev->mask & IN_MODIFY) {
-		pollFile(etry->pLstn, NULL);
-	} else {
-		DBGPRINTF("got non-expected inotify event:\n");
-		in_dbg_showEv(ev);
 	}
 }
 
 static void ATTR_NONNULL(1)
 in_processEvent(struct inotify_event *ev)
 {
-	wd_map_t *etry;
-	lstn_t *pLstn;
-	int iRet;
-	int ftIdx;
-	int wd;
-	uchar statefile[MAXFNAME];
-
 	if(ev->mask & IN_IGNORED) {
-		goto done;
-	} else if(ev->mask & IN_MOVED_FROM) {
-		/* Find wd entry and remove it */
-		etry =  wdmapLookup(ev->wd);
-		if(etry != NULL) {
-			ftIdx = fileTableSearchNoWildcard(&dirs[etry->dirIdx].active, (uchar*)ev->name);
-			DBGPRINTF("IN_MOVED_FROM Event (ftIdx=%d, name=%s)\n", ftIdx, ev->name);
-			if(ftIdx >= 0) {
-				/* Find listener and wd table index*/
-				pLstn = dirs[etry->dirIdx].active.listeners[ftIdx].pLstn;
-				wd = wdmapLookupListner(pLstn);
-
-				/* Remove file from inotify watch */
-				iRet = inotify_rm_watch(ino_fd, wd); /* Note this will TRIGGER IN_IGNORED Event! */
-				if (iRet != 0) {
-					DBGPRINTF("inotify_rm_watch error %d (ftIdx=%d, wd=%d, name=%s)\n",
-						errno, ftIdx, wd, ev->name);
-				} else {
-					DBGPRINTF("inotify_rm_watch successfully removed file from watch "
-						"(ftIdx=%d, wd=%d, name=%s)\n", ftIdx, wd, ev->name);
-				}
-
-				/* Store statefile name for later MOVED_TO event along with COOKIE */
-				pLstn->masterLstn->movedfrom_statefile = ustrdup(getStateFileName(pLstn,
-					statefile, sizeof(statefile), NULL) );
-				pLstn->masterLstn->movedfrom_cookie = ev->cookie;
-
-				/* do NOT remove statefile in this case!*/
-				in_removeFile(etry->dirIdx, pLstn, FALSE);
-				DBGPRINTF("IN_MOVED_FROM Event file removed file (wd=%d, name=%s)\n", wd, ev->name);
-			}
-		}
+		DBGPRINTF("imfile: got IN_IGNORED event\n");
 		goto done;
 	}
-	DBGPRINTF("in_processEvent process Event %x for %s\n", ev->mask, (uchar*)ev->name);
 
-	etry =  wdmapLookup(ev->wd);
+	DBGPRINTF("in_processEvent process Event %x for %s\n", ev->mask, ev->name);
+	const wd_map_t *const etry =  wdmapLookup(ev->wd);
 	if(etry == NULL) {
-		DBGPRINTF("could not lookup wd %d\n", ev->wd);
+		LogMsg(0, RS_RET_INTERNAL_ERROR, LOG_WARNING, "imfile: internal error? "
+			"inotify provided watch descriptor %d which we could not find "
+			"in our tables - ignored", ev->wd);
 		goto done;
 	}
-	if(etry->pLstn == NULL) { /* directory? */
-		in_handleDirEvent(ev, etry->dirIdx);
+	DBGPRINTF("in_processEvent process Event %x is_file %d, act->name '%s'\n",
+		ev->mask, etry->act->edge->is_file, etry->act->name);
+
+	if((ev->mask & IN_MOVED_FROM)) {
+		flag_in_move(etry->act->edge->node->edges, ev->name);
+	}
+	if(ev->mask & (IN_MOVED_FROM | IN_MOVED_TO))  {
+		fs_node_walk(etry->act->edge->node, poll_tree);
+	} else if(etry->act->edge->is_file) {
+		in_handleFileEvent(ev, etry); // esentially poll_file()!
 	} else {
-		in_handleFileEvent(ev, etry);
+		fs_node_walk(etry->act->edge->node, poll_tree);
 	}
 done:	return;
 }
 
-static void
-in_do_timeout_processing(void)
-{
-	int i;
-	DBGPRINTF("readTimeouts are configured, checking if some apply\n");
-
-	for(i = 0 ; i < nWdmap ; ++i) {
-		DBGPRINTF("wdmap %d, plstn %p\n", i, wdmap[i].pLstn);
-		lstn_t *const pLstn = wdmap[i].pLstn;
-		if(pLstn != NULL && strmReadMultiLine_isTimedOut(pLstn->pStrm)) {
-			DBGPRINTF("wdmap %d, timeout occured\n", i);
-			pollFile(pLstn, NULL);
-		}
-	}
-}
-
 
 /* Monitor files in inotify mode */
 #if !defined(_AIX)
